#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct AxisThresholdVisualization {
    #[serde(rename = "axisId")]
    axis_id: super::AxisId,
    #[serde(rename = "visibility")]
    visibility: bool,
    #[builder(custom(type = super::AxisThresholdGroup, convert = Box::new))]
    #[serde(rename = "thresholds")]
    thresholds: Box<super::AxisThresholdGroup>,
}
impl AxisThresholdVisualization {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        axis_id: super::AxisId,
        visibility: bool,
        thresholds: super::AxisThresholdGroup,
    ) -> Self {
        Self::builder()
            .axis_id(axis_id)
            .visibility(visibility)
            .thresholds(thresholds)
            .build()
    }
    #[inline]
    pub fn axis_id(&self) -> &super::AxisId {
        &self.axis_id
    }
    /// Determines it's current visibility in the time series chart.
    #[inline]
    pub fn visibility(&self) -> bool {
        self.visibility
    }
    #[inline]
    pub fn thresholds(&self) -> &super::AxisThresholdGroup {
        &*self.thresholds
    }
}
